﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace LibraryManagement
{
    public partial class Correction : Form
    {
        public Main main;
        public Correction(Main main)
        {
            this.main = main;
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (BookDataManage.instance.dicBookData.TryGetValue(ISBNTextBook.Text, out BookData data))
            {
                this.BookNameTextBook.Text = data.BookInfo.BookName;
                this.PublisherTextBook.Text = data.BookInfo.Publisher;
                this.SeletSortLable.Text = data.BookInfo.Sort;
                this.PriceTextBook.Text = data.BookInfo.Price.ToString();
                this.Search.Enabled = false;
                this.ISBNTextBook.Enabled = false;
                this.groupBox1.Enabled = true;
            }
            else
            {
                MessageBox.Show("해당 값이 없습니다.", "수정 불가");
            }
            
        }

        private void OUT_Click(object sender, EventArgs e)
        {
            main.Opacity = 1;
            main.Enabled = true;
            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            bool Check = this.ISBNTextBook.Text != "" && this.BookNameTextBook.Text != "" && this.PublisherTextBook.Text != "선택하세요"
               && this.PriceTextBook.Text != "" && int.TryParse(this.PriceTextBook.Text, out int result);
            if (Check)
            {
                BookData bookData = new BookData();
                bookData.BookInfo.ISBN = this.ISBNTextBook.Text;
                bookData.BookInfo.BookName = this.BookNameTextBook.Text;
                bookData.BookInfo.Publisher = this.PublisherTextBook.Text;
                bookData.BookInfo.Sort = this.SeletSortLable.Text;
                bookData.BookInfo.Price = Convert.ToInt32(this.PriceTextBook.Text);
                bookData.BookInfo.RegDAta = DateTime.Now;
                BookDataManage.instance.dicBookData.Remove(bookData.BookInfo.ISBN);
                BookDataManage.instance.dicBookData.Add(bookData.BookInfo.ISBN, bookData);
                BookDataManage.instance.SaveBookData();
                MessageBox.Show($"수정되었습니다.\n ISBN : {bookData.BookInfo.ISBN} \n 책이름 : {bookData.BookInfo.BookName}\n " +
                    $"출판사 : {bookData.BookInfo.Publisher}\n 분류 : {bookData.BookInfo.Sort}\n 가격 : {bookData.BookInfo.Price} \n 등록일자 : {bookData.BookInfo.RegDAta}  ", "확인창");
                this.ISBNTextBook.Text = "";
                this.BookNameTextBook.Text = "";
                this.PublisherTextBook.Text = "";
                this.SeletSortLable.Text = "선택하세요";
                this.PriceTextBook.Text = "";
                this.groupBox1.Enabled = false;
                this.Search.Enabled = true;
                this.ISBNTextBook.Enabled = true;

            }
            else
            {

                MessageBox.Show("빈공간/분류/가격을 확인해주세요", "등록 오류");
            }

        }

        private void SortComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            ComboBox cb = (ComboBox)sender;
            this.SeletSortLable.Text = cb.SelectedItem.ToString();
        }
    }
}
