﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace LibraryManagement
{
    public partial class Remove : Form
    {
        public Main main;
        public Remove(Main main)
        {
            this.main = main;
            InitializeComponent();
        }

        private void Search_Click(object sender, EventArgs e)
        {
            if (BookDataManage.instance.dicBookData.TryGetValue(ISBNTextBook.Text, out BookData data))
            {
                this.BookNameTextBook.Text = data.BookInfo.BookName;
                this.PublisherTextBook.Text = data.BookInfo.Publisher;
                this.SeletSortLable.Text = data.BookInfo.Sort;
                this.PriceTextBook.Text = data.BookInfo.Price.ToString();
                this.RemoveButton.Enabled = true;
            }
            else
            {
                MessageBox.Show("해당 값이 없습니다.", "수정 불가");
            }

        }

        private void Out_Click(object sender, EventArgs e)
        {
            main.Opacity = 1;
            main.Enabled = true;
            this.Close();
        }

        private void RemoveButton_Click(object sender, EventArgs e)
        {
            const string message = "정말 삭제하시겠습니까?";
        
            const string caption = "확인 메시지";

            var check = MessageBox.Show(message, caption,MessageBoxButtons.YesNo,MessageBoxIcon.Question);

            if (check == DialogResult.Yes)
            {

                bool Check = this.ISBNTextBook.Text != "" && this.BookNameTextBook.Text != "" && this.PublisherTextBook.Text != "선택하세요"
               && this.PriceTextBook.Text != "" && int.TryParse(this.PriceTextBook.Text, out int result);
                if (Check)
                {
                    BookData bookData = new BookData();
                    bookData.BookInfo.ISBN = this.ISBNTextBook.Text;
                    bookData.BookInfo.BookName = this.BookNameTextBook.Text;
                    bookData.BookInfo.Publisher = this.PublisherTextBook.Text;
                    bookData.BookInfo.Sort = this.SeletSortLable.Text;
                    bookData.BookInfo.Price = Convert.ToInt32(this.PriceTextBook.Text);
                    bookData.BookInfo.RegDAta = DateTime.Now;
                    BookDataManage.instance.dicBookData.Remove(bookData.BookInfo.ISBN);
                    BookDataManage.instance.SaveBookData();
                    this.ISBNTextBook.Text = "";
                    this.BookNameTextBook.Text = "";
                    this.PublisherTextBook.Text = "";
                    this.SeletSortLable.Text = "선택하세요";
                    this.PriceTextBook.Text = "";
                    this.RemoveButton.Enabled = false;
                }
                else
                {

                    MessageBox.Show("해당 책을 찾을 수 없습니다.", "오류");
                }

            }
            
        }
    }
}
