﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Windows.Forms;

namespace LibraryManagement
{
    public partial class Serach : Form
    {
        public Main main;
        public Dictionary<string, BookData> dicBookData = new Dictionary<string, BookData>();
        public List<BookData> listSort = new List<BookData>();
        DataTable table = new DataTable();
        public Serach(Main main)
        {
            this.main = main;
            InitializeComponent();
            table.Columns.Add("ISBN", typeof(Int64));
            table.Columns.Add("도서명", typeof(string));
            table.Columns.Add("출판사", typeof(string));
            table.Columns.Add("분류", typeof(string));
            table.Columns.Add("가격", typeof(Int32));
            table.Columns.Add("등록일", typeof(DateTime));
            this.dicBookData = BookDataManage.instance.dicBookData;
            foreach (KeyValuePair<string, BookData> data in this.dicBookData)
            {
                table.Rows.Add($"{Int64.Parse(data.Value.BookInfo.ISBN)}",
                    $"{data.Value.BookInfo.BookName}",
                    $"{data.Value.BookInfo.Publisher}",
                    $"{data.Value.BookInfo.Sort}",
                    $"{data.Value.BookInfo.Price}",
                    $"{data.Value.BookInfo.RegDAta}");
            }

            dataGridView1.DataSource = table;

            foreach (KeyValuePair<string, BookData> data in this.dicBookData)
            {
                this.listSort.Add(data.Value);
            }

            this.comboBox2.Enabled = false;
            this.comboBox3.Enabled = false;
            this.SerachOK.Enabled = false;
        }

        private void OUT_Click(object sender, EventArgs e)
        {
            main.Opacity = 1;
            main.Enabled = true;
            this.Close();
        }



        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.comboBox3.Enabled = true;
        }

        private void SerachOK_Click(object sender, EventArgs e)
        {


            ((DataTable)dataGridView1.DataSource).Rows.Clear();
            dataGridView1.Refresh();


            string com1 = string.Format(this.comboBox1.SelectedItem.ToString());
            string com2 = string.Format(this.comboBox2.SelectedItem.ToString());
            string com3 = string.Format(this.comboBox3.SelectedItem.ToString());


            if (com1 == "등록날짜")
            {

                if (com2 == "버블정렬")
                {

                    if (com3 == "오름차순")
                    {
                        for (int i = 0; i < this.listSort.Count - 1; i++)
                        {
                            for (int j = i + 1; j < this.listSort.Count; j++)
                            {
                                if (this.listSort[i].BookInfo.RegDAta > this.listSort[j].BookInfo.RegDAta)
                                {
                                    BookData temp;
                                    temp = listSort[i];
                                    listSort[i] = listSort[j];
                                    listSort[j] = temp;
                                }
                            }
                        }
                    }

                    else if (com3 == "내림차순")
                    {
                        for (int i = 0; i < this.listSort.Count - 1; i++)
                        {
                            for (int j = i + 1; j < this.listSort.Count; j++)
                            {
                                if (this.listSort[i].BookInfo.RegDAta < this.listSort[j].BookInfo.RegDAta)
                                {
                                    BookData temp;
                                    temp = listSort[i];
                                    listSort[i] = listSort[j];
                                    listSort[j] = temp;
                                }
                            }
                        }
                    }
                }


                else if (com2 == "선택정렬")
                {
                    if (com3 == "오름차순")
                    {
                        for (int i = 0; i < this.listSort.Count; i++)
                        {
                            BookData temp;
                            int index = i;
                            for (int j = i + 1; j < this.listSort.Count; j++)
                            {
                                if (this.listSort[j].BookInfo.RegDAta < this.listSort[index].BookInfo.RegDAta)
                                {
                                    index = j;
                                }
                            }
                            if (index == i)
                            {
                                continue;
                            }
                            temp = this.listSort[index];
                            this.listSort[index] = this.listSort[i];
                            this.listSort[i] = temp;
                        }

                    }

                    else if (com3 == "내림차순")
                    {
                        for (int i = 0; i < this.listSort.Count; i++)
                        {
                            BookData temp;
                            int index = i;
                            for (int j = i + 1; j < this.listSort.Count; j++)
                            {
                                if (this.listSort[j].BookInfo.RegDAta > this.listSort[index].BookInfo.RegDAta)
                                {
                                    index = j;
                                }
                            }
                            if (index == i)
                            {
                                continue;
                            }
                            temp = this.listSort[index];
                            this.listSort[index] = this.listSort[i];
                            this.listSort[i] = temp;
                        }
                    }


                }

                else if (com2 == "퀵정렬")
                {
                    if (com3 == "오름차순")
                    {
                        this.listSort = QuickSort1Date(this.listSort, 0, listSort.Count - 1);
                    }
                    else if (com3 == "내림차순")
                    {
                        this.listSort = QuickSort2Date(this.listSort, 0, listSort.Count - 1);
                    }

                }


            }

            else if (com1 == "가격")
            {

                if (com2 == "버블정렬")
                {
                    if (com3 == "오름차순")
                    {
                        for (int i = 0; i < this.listSort.Count - 1; i++)
                        {
                            for (int j = i + 1; j < this.listSort.Count; j++)
                            {
                                if (this.listSort[i].BookInfo.Price > this.listSort[j].BookInfo.Price)
                                {
                                    BookData temp;
                                    temp = listSort[i];
                                    listSort[i] = listSort[j];
                                    listSort[j] = temp;
                                }
                            }
                        }
                    }
                    else if (com3 == "내림차순")
                    {
                        for (int i = 0; i < this.listSort.Count - 1; i++)
                        {
                            for (int j = i + 1; j < this.listSort.Count; j++)
                            {
                                if (this.listSort[i].BookInfo.Price < this.listSort[j].BookInfo.Price)
                                {
                                    BookData temp;
                                    temp = listSort[i];
                                    listSort[i] = listSort[j];
                                    listSort[j] = temp;
                                }
                            }
                        }
                    }




                }

                else if (com2 == "선택정렬")
                {

                    if (com3 == "오름차순")
                    {
                        BookData temp;
                        int index;

                        for (int i = 0; i < this.listSort.Count; i++)
                        {

                            index = i;

                            for (int j = i + 1; j < this.listSort.Count; j++)
                            {

                                if (this.listSort[j].BookInfo.Price < this.listSort[index].BookInfo.Price)
                                {
                                    index = j;
                                }

                            }

                            if (index == i)
                            {
                                continue;
                            }

                            temp = this.listSort[index];
                            this.listSort[index] = this.listSort[i];
                            this.listSort[i] = temp;


                        }
                    }
                    else if (com3 == "내림차순")
                    {
                        BookData temp;
                        int index;

                        for (int i = 0; i < this.listSort.Count; i++)
                        {

                            index = i;

                            for (int j = i + 1; j < this.listSort.Count; j++)
                            {

                                if (this.listSort[j].BookInfo.Price > this.listSort[index].BookInfo.Price)
                                {
                                    index = j;
                                }

                            }

                            if (index == i)
                            {
                                continue;
                            }

                            temp = this.listSort[index];
                            this.listSort[index] = this.listSort[i];
                            this.listSort[i] = temp;


                        }
                    }




                }

                else if (com2 == "퀵정렬")
                {
                    if (com3 == "오름차순")
                    {
                        this.listSort = QuickSort1Price(this.listSort, 0, listSort.Count - 1);
                    }
                    else if (com3 == "내림차순")
                    {
                        this.listSort = QuickSort2Price(this.listSort, 0, listSort.Count - 1);
                    }

                }


            }


            foreach (BookData data in this.listSort)
            {
                table.Rows.Add($"{Int64.Parse(data.BookInfo.ISBN)}",
                    $"{data.BookInfo.BookName}",
                    $"{data.BookInfo.Publisher}",
                    $"{data.BookInfo.Sort}",
                    $"{data.BookInfo.Price}",
                    $"{data.BookInfo.RegDAta}");
            }

            dataGridView1.DataSource = table;
        }

        public List<BookData> QuickSort1Date(List<BookData> list, int start, int end)
        {
            int startBase = start;
            int endBase = end;

            BookData temp;
            DateTime pivot = list[endBase].BookInfo.RegDAta;

            while (true)
            {
                while (pivot >= list[start].BookInfo.RegDAta && start < end) start++;
                while (pivot <= list[end].BookInfo.RegDAta && start < end) end--;

                if (start >= end)
                    break;

                temp = list[start];
                list[start] = list[end];
                list[end] = temp;
            }

            temp = list[endBase];
            list[endBase] = list[start];
            list[start] = temp;

            if (startBase < start)
                list = QuickSort1Date(list, startBase, start - 1);
            if (endBase > end)
                list = QuickSort1Date(list, start + 1, endBase);

            return list;
        }

        public List<BookData> QuickSort2Date(List<BookData> list, int start, int end)
        {
            int startBase = start;
            int endBase = end;

            BookData temp;
            DateTime pivot = list[endBase].BookInfo.RegDAta;

            while (true)
            {
                while (pivot <= list[start].BookInfo.RegDAta && start < end) start++;
                while (pivot >= list[end].BookInfo.RegDAta && start < end) end--;

                if (start >= end)
                    break;

                temp = list[start];
                list[start] = list[end];
                list[end] = temp;
            }

            temp = list[endBase];
            list[endBase] = list[start];
            list[start] = temp;

            if (startBase < start)
                list = QuickSort2Date(list, startBase, start - 1);
            if (endBase > end)
                list = QuickSort2Date(list, start + 1, endBase);

            return list;
        }






        public List<BookData> QuickSort1Price(List<BookData> list, int start, int end)
        {
            int startBase = start;
            int endBase = end;

            BookData temp;
            int pivot = list[endBase].BookInfo.Price;

            while (true)
            {
                while (pivot >= list[start].BookInfo.Price && start < end) start++;
                while (pivot <= list[end].BookInfo.Price && start < end) end--;

                if (start >= end)
                    break;

                temp = list[start];
                list[start] = list[end];
                list[end] = temp;
            }

            temp = list[endBase];
            list[endBase] = list[start];
            list[start] = temp;

            if (startBase < start)
                list = QuickSort1Price(list, startBase, start - 1);
            if (endBase > end)
                list = QuickSort1Price(list, start + 1, endBase);

            return list;
        }
        public List<BookData> QuickSort2Price(List<BookData> list, int start, int end)
        {
            int startBase = start;
            int endBase = end;

            BookData temp;
            int pivot = list[endBase].BookInfo.Price;

            while (true)
            {
                while (pivot <= list[start].BookInfo.Price && start < end) start++;
                while (pivot >= list[end].BookInfo.Price && start < end) end--;

                if (start >= end)
                    break;

                temp = list[start];
                list[start] = list[end];
                list[end] = temp;
            }

            temp = list[endBase];
            list[endBase] = list[start];
            list[start] = temp;

            if (startBase < start)
                list = QuickSort2Price(list, startBase, start - 1);
            if (endBase > end)
                list = QuickSort2Price(list, start + 1, endBase);

            return list;
        }
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.comboBox2.Enabled = true;
        }

        private void dataGridView1_MouseClick(object sender, MouseEventArgs e)
        {

        }

        private void dataGridView1_CellContentDoubleClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void comboBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.SerachOK.Enabled = true;
        }
    }
}
